diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/config.c tomato121/release/src/router/pppd/pppd/plugins/radius/config.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/config.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/config.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,550 @@
+/*
+ * $Id: config.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1996,1997 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+#include <options.h>
+
+static int test_config(char *);
+
+/*
+ * Function: find_option
+ *
+ * Purpose: find an option in the option list
+ *
+ * Returns: pointer to option on success, NULL otherwise
+ */
+
+static OPTION *find_option(char *optname, unsigned int type)
+{
+	int i;
+
+	/* there're so few options that a binary search seems not necessary */
+	for (i = 0; i < num_options; i++) {
+		if (!strcmp(config_options[i].name, optname) &&
+		    (config_options[i].type & type))
+			return &config_options[i];
+	}
+
+	return NULL;
+}
+
+/*
+ * Function: set_option_...
+ *
+ * Purpose: set a specific option doing type conversions
+ *
+ * Returns: 0 on success, -1 on failure
+ */
+
+static int set_option_str(char *filename, int line, OPTION *option, char *p)
+{
+	if (p)
+		option->val = (void *) strdup(p);
+	else
+		option->val = NULL;
+
+	return 0;
+}
+
+static int set_option_int(char *filename, int line, OPTION *option, char *p)
+{
+	int *iptr;
+
+	if (p == NULL) {
+		error("%s: line %d: bogus option value", filename, line);
+		return (-1);
+	}
+
+	if ((iptr = (int *) malloc(sizeof(iptr))) == NULL) {
+		novm("read_config");
+		return (-1);
+	}
+
+	*iptr = atoi(p);
+	option->val = (void *) iptr;
+
+	return 0;
+}
+
+static int set_option_srv(char *filename, int line, OPTION *option, char *p)
+{
+	SERVER *serv;
+	char *q;
+	struct servent *svp;
+	int i;
+
+	if (p == NULL) {
+		error("%s: line %d: bogus option value", filename, line);
+		return (-1);
+	}
+
+	serv = (SERVER *) option->val;
+
+	for (i = 0; i < serv->max; i++) {
+		free(serv->name[i]);
+	}
+	serv->max = 0;
+
+	while ((p = strtok(p, ", \t")) != NULL) {
+
+		if ((q = strchr(p,':')) != NULL) {
+			*q = '\0';
+			q++;
+			serv->port[serv->max] = atoi(q);
+		} else {
+			if (!strcmp(option->name,"authserver"))
+				if ((svp = getservbyname ("radius", "udp")) == NULL)
+					serv->port[serv->max] = PW_AUTH_UDP_PORT;
+				else
+					serv->port[serv->max] = ntohs ((unsigned int) svp->s_port);
+			else if (!strcmp(option->name, "acctserver"))
+				if ((svp = getservbyname ("radacct", "udp")) == NULL)
+					serv->port[serv->max] = PW_ACCT_UDP_PORT;
+				else
+					serv->port[serv->max] = ntohs ((unsigned int) svp->s_port);
+			else {
+				error("%s: line %d: no default port for %s", filename, line, option->name);
+				return (-1);
+			}
+		}
+
+		serv->name[serv->max++] = strdup(p);
+
+		p = NULL;
+	}
+
+	return 0;
+}
+
+static int set_option_auo(char *filename, int line, OPTION *option, char *p)
+{
+	int *iptr;
+
+	if (p == NULL) {
+		warn("%s: line %d: bogus option value", filename, line);
+		return (-1);
+	}
+
+	if ((iptr = (int *) malloc(sizeof(iptr))) == NULL) {
+			novm("read_config");
+			return (-1);
+	}
+
+	*iptr = 0;
+	p = strtok(p, ", \t");
+
+	if (!strncmp(p, "local", 5))
+			*iptr = AUTH_LOCAL_FST;
+	else if (!strncmp(p, "radius", 6))
+			*iptr = AUTH_RADIUS_FST;
+	else {
+		error("%s: auth_order: unknown keyword: %s", filename, p);
+		return (-1);
+	}
+
+	p = strtok(NULL, ", \t");
+
+	if (p && (*p != '\0')) {
+		if ((*iptr & AUTH_RADIUS_FST) && !strcmp(p, "local"))
+			*iptr = (*iptr) | AUTH_LOCAL_SND;
+		else if ((*iptr & AUTH_LOCAL_FST) && !strcmp(p, "radius"))
+			*iptr = (*iptr) | AUTH_RADIUS_SND;
+		else {
+			error("%s: auth_order: unknown or unexpected keyword: %s", filename, p);
+			return (-1);
+		}
+	}
+
+	option->val = (void *) iptr;
+
+	return 0;
+}
+
+
+/*
+ * Function: rc_read_config
+ *
+ * Purpose: read the global config file
+ *
+ * Returns: 0 on success, -1 when failure
+ */
+
+int rc_read_config(char *filename)
+{
+	FILE *configfd;
+	char buffer[512], *p;
+	OPTION *option;
+	int line, pos;
+
+	if ((configfd = fopen(filename,"r")) == NULL)
+	{
+		error("rc_read_config: can't open %s: %m", filename);
+		return (-1);
+	}
+
+	line = 0;
+	while ((fgets(buffer, sizeof(buffer), configfd) != NULL))
+	{
+		line++;
+		p = buffer;
+
+		if ((*p == '\n') || (*p == '#') || (*p == '\0'))
+			continue;
+
+		p[strlen(p)-1] = '\0';
+
+
+		if ((pos = strcspn(p, "\t ")) == 0) {
+			error("%s: line %d: bogus format: %s", filename, line, p);
+			return (-1);
+		}
+
+		p[pos] = '\0';
+
+		if ((option = find_option(p, OT_ANY)) == NULL) {
+			error("%s: line %d: unrecognized keyword: %s", filename, line, p);
+			return (-1);
+		}
+
+		if (option->status != ST_UNDEF) {
+			error("%s: line %d: duplicate option line: %s", filename, line, p);
+			return (-1);
+		}
+
+		p += pos+1;
+		while (isspace(*p))
+			p++;
+
+		switch (option->type) {
+			case OT_STR:
+				 if (set_option_str(filename, line, option, p) < 0)
+					return (-1);
+				break;
+			case OT_INT:
+				 if (set_option_int(filename, line, option, p) < 0)
+					return (-1);
+				break;
+			case OT_SRV:
+				 if (set_option_srv(filename, line, option, p) < 0)
+					return (-1);
+				break;
+			case OT_AUO:
+				 if (set_option_auo(filename, line, option, p) < 0)
+					return (-1);
+				break;
+			default:
+				fatal("rc_read_config: impossible case branch!");
+				abort();
+		}
+	}
+	fclose(configfd);
+
+	return test_config(filename);
+}
+
+/*
+ * Function: rc_conf_str, rc_conf_int, rc_conf_src
+ *
+ * Purpose: get the value of a config option
+ *
+ * Returns: config option value
+ */
+
+char *rc_conf_str(char *optname)
+{
+	OPTION *option;
+
+	option = find_option(optname, OT_STR);
+
+	if (option == NULL)
+		fatal("rc_conf_str: unkown config option requested: %s", optname);
+		return (char *)option->val;
+}
+
+int rc_conf_int(char *optname)
+{
+	OPTION *option;
+
+	option = find_option(optname, OT_INT|OT_AUO);
+
+	if (option == NULL)
+		fatal("rc_conf_int: unkown config option requested: %s", optname);
+	return *((int *)option->val);
+}
+
+SERVER *rc_conf_srv(char *optname)
+{
+	OPTION *option;
+
+	option = find_option(optname, OT_SRV);
+
+	if (option == NULL)
+		fatal("rc_conf_srv: unkown config option requested: %s", optname);
+	return (SERVER *)option->val;
+}
+
+/*
+ * Function: test_config
+ *
+ * Purpose: test the configuration the user supplied
+ *
+ * Returns: 0 on success, -1 when failure
+ */
+
+static int test_config(char *filename)
+{
+#if 0
+	struct stat st;
+	char	    *file;
+#endif
+
+	if (!(rc_conf_srv("authserver")->max))
+	{
+		error("%s: no authserver specified", filename);
+		return (-1);
+	}
+	if (!(rc_conf_srv("acctserver")->max))
+	{
+		error("%s: no acctserver specified", filename);
+		return (-1);
+	}
+	if (!rc_conf_str("servers"))
+	{
+		error("%s: no servers file specified", filename);
+		return (-1);
+	}
+	if (!rc_conf_str("dictionary"))
+	{
+		error("%s: no dictionary specified", filename);
+		return (-1);
+	}
+
+	if (rc_conf_int("radius_timeout") <= 0)
+	{
+		error("%s: radius_timeout <= 0 is illegal", filename);
+		return (-1);
+	}
+	if (rc_conf_int("radius_retries") <= 0)
+	{
+		error("%s: radius_retries <= 0 is illegal", filename);
+		return (-1);
+	}
+
+#if 0
+	file = rc_conf_str("login_local");
+	if (stat(file, &st) == 0)
+	{
+		if (!S_ISREG(st.st_mode)) {
+			error("%s: not a regular file: %s", filename, file);
+			return (-1);
+		}
+	} else {
+		error("%s: file not found: %s", filename, file);
+		return (-1);
+	}
+	file = rc_conf_str("login_radius");
+	if (stat(file, &st) == 0)
+	{
+		if (!S_ISREG(st.st_mode)) {
+			error("%s: not a regular file: %s", filename, file);
+			return (-1);
+		}
+	} else {
+		error("%s: file not found: %s", filename, file);
+		return (-1);
+	}
+#endif
+
+#if 0
+	if (rc_conf_int("login_tries") <= 0)
+	{
+		error("%s: login_tries <= 0 is illegal", filename);
+		return (-1);
+	}
+#endif
+	if (rc_conf_str("seqfile") == NULL)
+	{
+		error("%s: seqfile not specified", filename);
+		return (-1);
+	}
+#if 0
+	if (rc_conf_int("login_timeout") <= 0)
+	{
+		error("%s: login_timeout <= 0 is illegal", filename);
+		return (-1);
+	}
+#endif
+	if (rc_conf_str("mapfile") == NULL)
+	{
+		error("%s: mapfile not specified", filename);
+		return (-1);
+	}
+#if 0
+	if (rc_conf_str("nologin") == NULL)
+	{
+		error("%s: nologin not specified", filename);
+		return (-1);
+	}
+#endif
+
+	return 0;
+}
+
+/*
+ * Function: rc_find_match
+ *
+ * Purpose: see if ip_addr is one of the ip addresses of hostname
+ *
+ * Returns: 0 on success, -1 when failure
+ *
+ */
+
+static int find_match (UINT4 *ip_addr, char *hostname)
+{
+	UINT4           addr;
+	char          **paddr;
+	struct hostent *hp;
+
+	if (rc_good_ipaddr (hostname) == 0)
+	{
+		if (*ip_addr == ntohl(inet_addr (hostname)))
+		{
+			return (0);
+		}
+	}
+	else
+	{
+		if ((hp = gethostbyname (hostname)) == (struct hostent *) NULL)
+		{
+			return (-1);
+		}
+		for (paddr = hp->h_addr_list; *paddr; paddr++)
+		{
+			addr = ** (UINT4 **) paddr;
+			if (ntohl(addr) == *ip_addr)
+			{
+				return (0);
+			}
+		}
+	}
+	return (-1);
+}
+
+/*
+ * Function: rc_find_server
+ *
+ * Purpose: search a server in the servers file
+ *
+ * Returns: 0 on success, -1 on failure
+ *
+ */
+
+int rc_find_server (char *server_name, UINT4 *ip_addr, char *secret)
+{
+	UINT4	myipaddr = 0;
+	int             len;
+	int             result;
+	FILE           *clientfd;
+	char           *h;
+	char           *s;
+	char           *host2;
+	char            buffer[128];
+	char            hostnm[AUTH_ID_LEN + 1];
+
+	/* Get the IP address of the authentication server */
+	if ((*ip_addr = rc_get_ipaddr (server_name)) == (UINT4) 0)
+		return (-1);
+
+	if ((clientfd = fopen (rc_conf_str("servers"), "r")) == (FILE *) NULL)
+	{
+		error("rc_find_server: couldn't open file: %m: %s", rc_conf_str("servers"));
+		return (-1);
+	}
+
+	myipaddr = rc_own_ipaddress();
+
+	result = 0;
+	while (fgets (buffer, sizeof (buffer), clientfd) != (char *) NULL)
+	{
+		if (*buffer == '#')
+			continue;
+
+		if ((h = strtok (buffer, " \t\n")) == NULL) /* first hostname */
+			continue;
+
+		memset (hostnm, '\0', AUTH_ID_LEN);
+		len = strlen (h);
+		if (len > AUTH_ID_LEN)
+		{
+			len = AUTH_ID_LEN;
+		}
+		strncpy (hostnm, h, (size_t) len);
+		hostnm[AUTH_ID_LEN] = '\0';
+
+		if ((s = strtok (NULL, " \t\n")) == NULL) /* and secret field */
+			continue;
+
+		memset (secret, '\0', MAX_SECRET_LENGTH);
+		len = strlen (s);
+		if (len > MAX_SECRET_LENGTH)
+		{
+			len = MAX_SECRET_LENGTH;
+		}
+		strncpy (secret, s, (size_t) len);
+		secret[MAX_SECRET_LENGTH] = '\0';
+
+		if (!strchr (hostnm, '/')) /* If single name form */
+		{
+			if (find_match (ip_addr, hostnm) == 0)
+			{
+				result++;
+				break;
+			}
+		}
+		else /* <name1>/<name2> "paired" form */
+		{
+			strtok (hostnm, "/");
+			if (find_match (&myipaddr, hostnm) == 0)
+			{	     /* If we're the 1st name, target is 2nd */
+				host2 = strtok (NULL, " ");
+				if (find_match (ip_addr, host2) == 0)
+				{
+					result++;
+					break;
+				}
+			}
+			else	/* If we were 2nd name, target is 1st name */
+			{
+				if (find_match (ip_addr, hostnm) == 0)
+				{
+					result++;
+					break;
+				}
+			}
+		}
+	}
+	fclose (clientfd);
+	if (result == 0)
+	{
+		memset (buffer, '\0', sizeof (buffer));
+		memset (secret, '\0', sizeof (secret));
+		error("rc_find_server: couldn't find RADIUS server %s in %s",
+		      server_name, rc_conf_str("servers"));
+		return (-1);
+	}
+	return 0;
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/COPYRIGHT tomato121/release/src/router/pppd/pppd/plugins/radius/COPYRIGHT
--- tomato/release/src/router/pppd/pppd/plugins/radius/COPYRIGHT	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/COPYRIGHT	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,90 @@
+See the respective source files to find out which copyrights apply.
+
+------------------------------------------------------------------------------
+Copyright (C) 2002 Roaring Penguin Software Inc.
+
+Permission to use, copy, modify, and distribute this software for any
+purpose and without fee is hereby granted, provided that this
+copyright and permission notice appear on all copies and supporting
+documentation, the name of Roaring Penguin Software Inc. not be used
+in advertising or publicity pertaining to distribution of the program
+without specific prior permission, and notice be given in supporting
+documentation that copying and distribution is by permission of
+Roaring Penguin Software Inc..
+
+Roaring Penguin Software Inc. makes no representations about the
+suitability of this software for any purpose.  It is provided "as is"
+without express or implied warranty.
+
+------------------------------------------------------------------------------
+Copyright (C) 1995,1996,1997,1998 Lars Fenneberg <lf@elemental.net>
+
+Permission to use, copy, modify, and distribute this software for any
+purpose and without fee is hereby granted, provided that this copyright and
+permission notice appear on all copies and supporting documentation, the
+name of Lars Fenneberg not be used in advertising or publicity pertaining to
+distribution of the program without specific prior permission, and notice be
+given in supporting documentation that copying and distribution is by
+permission of Lars Fenneberg.
+
+Lars Fenneberg makes no representations about the suitability of this
+software for any purpose.  It is provided "as is" without express or implied
+warranty.
+
+------------------------------------------------------------------------------
+Copyright 1992 Livingston Enterprises, Inc.
+Livingston Enterprises, Inc. 6920 Koll Center Parkway Pleasanton, CA  94566
+
+Permission to use, copy, modify, and distribute this software for any
+purpose and without fee is hereby granted, provided that this copyright
+and permission notice appear on all copies and supporting documentation,
+the name of Livingston Enterprises, Inc. not be used in advertising or
+publicity pertaining to distribution of the program without specific
+prior permission, and notice be given in supporting documentation that
+copying and distribution is by permission of Livingston Enterprises, Inc.
+
+Livingston Enterprises, Inc. makes no representations about the suitability
+of this software for any purpose.  It is provided "as is" without express
+or implied warranty.
+------------------------------------------------------------------------------
+[C] The Regents of the University of Michigan and Merit Network, Inc. 1992,
+1993, 1994, 1995 All Rights Reserved
+
+Permission to use, copy, modify, and distribute this software and its
+documentation for any purpose and without fee is hereby granted, provided
+that the above copyright notice and this permission notice appear in all
+copies of the software and derivative works or modified versions thereof,
+and that both the copyright notice and this permission and disclaimer
+notice appear in supporting documentation.
+
+THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
+EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE REGENTS OF THE
+UNIVERSITY OF MICHIGAN AND MERIT NETWORK, INC. DO NOT WARRANT THAT THE
+FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
+THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE.  The Regents of the
+University of Michigan and Merit Network, Inc. shall not be liable for any
+special, indirect, incidental or consequential damages with respect to any
+claim by Licensee or any third party arising from use of the software.
+------------------------------------------------------------------------------
+Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991.
+All rights reserved.
+
+License to copy and use this software is granted provided that it
+is identified as the "RSA Data Security, Inc. MD5 Message-Digest
+Algorithm" in all material mentioning or referencing this software
+or this function.
+
+License is also granted to make and use derivative works provided
+that such works are identified as "derived from the RSA Data
+Security, Inc. MD5 Message-Digest Algorithm" in all material
+mentioning or referencing the derived work.
+
+RSA Data Security, Inc. makes no representations concerning either
+the merchantability of this software or the suitability of this
+software for any particular purpose. It is provided "as is"
+without express or implied warranty of any kind.
+
+These notices must be retained in any copies of any part of this
+documentation and/or software.
+------------------------------------------------------------------------------
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/dict.c tomato121/release/src/router/pppd/pppd/plugins/radius/dict.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/dict.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/dict.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,450 @@
+/*
+ * $Id: dict.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 2002 Roaring Penguin Software Inc.
+ *
+ * Copyright (C) 1995,1996,1997 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+
+static DICT_ATTR *dictionary_attributes = NULL;
+static DICT_VALUE *dictionary_values = NULL;
+static VENDOR_DICT *vendor_dictionaries = NULL;
+
+/*
+ * Function: rc_read_dictionary
+ *
+ * Purpose: Initialize the dictionary.  Read all ATTRIBUTES into
+ *	    the dictionary_attributes list.  Read all VALUES into
+ *	    the dictionary_values list.  Construct VENDOR dictionaries
+ *          as required.
+ *
+ */
+
+int rc_read_dictionary (char *filename)
+{
+	FILE           *dictfd;
+	char            dummystr[AUTH_ID_LEN];
+	char            namestr[AUTH_ID_LEN];
+	char            valstr[AUTH_ID_LEN];
+	char            attrstr[AUTH_ID_LEN];
+	char            typestr[AUTH_ID_LEN];
+	char            vendorstr[AUTH_ID_LEN];
+	int             line_no;
+	DICT_ATTR      *attr;
+	DICT_VALUE     *dval;
+	VENDOR_DICT    *vdict;
+	char            buffer[256];
+	int             value;
+	int             type;
+	int             n;
+	int             retcode;
+	if ((dictfd = fopen (filename, "r")) == (FILE *) NULL)
+	{
+		error( "rc_read_dictionary: couldn't open dictionary %s: %s",
+				filename, strerror(errno));
+		return (-1);
+	}
+
+	line_no = 0;
+	retcode = 0;
+	while (fgets (buffer, sizeof (buffer), dictfd) != (char *) NULL)
+	{
+		line_no++;
+
+		/* Skip empty space */
+		if (*buffer == '#' || *buffer == '\0' || *buffer == '\n')
+		{
+			continue;
+		}
+
+		if (strncmp (buffer, "VENDOR", 6) == 0) {
+		    /* Read the VENDOR line */
+		    if (sscanf(buffer, "%s%s%d", dummystr, namestr, &value) != 3) {
+			error("rc_read_dictionary: invalid vendor on line %d of dictionary %s",
+			      line_no, filename);
+			retcode = -1;
+			break;
+		    }
+		    /* Validate entry */
+		    if (strlen (namestr) > NAME_LENGTH) {
+			error("rc_read_dictionary: invalid name length on line %d of dictionary %s",
+			      line_no, filename);
+			retcode = -1;
+			break;
+		    }
+		    /* Create new vendor entry */
+		    vdict = (VENDOR_DICT *) malloc (sizeof (VENDOR_DICT));
+		    if (!vdict) {
+			novm("rc_read_dictionary");
+			retcode = -1;
+			break;
+		    }
+		    strcpy(vdict->vendorname, namestr);
+		    vdict->vendorcode = value;
+		    vdict->attributes = NULL;
+		    vdict->next = vendor_dictionaries;
+		    vendor_dictionaries = vdict;
+		}
+		else if (strncmp (buffer, "ATTRIBUTE", 9) == 0)
+		{
+
+			/* Read the ATTRIBUTE line.  It is one of:
+			 * ATTRIBUTE attr_name attr_val type         OR
+			 * ATTRIBUTE attr_name attr_val type vendor  */
+			vendorstr[0] = 0;
+			n = sscanf(buffer, "%s%s%s%s%s", dummystr, namestr, valstr, typestr, vendorstr);
+			if (n != 4 && n != 5)
+			{
+				error("rc_read_dictionary: invalid attribute on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			/*
+			 * Validate all entries
+			 */
+			if (strlen (namestr) > NAME_LENGTH)
+			{
+				error("rc_read_dictionary: invalid name length on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			if (strlen (vendorstr) > NAME_LENGTH)
+			{
+				error("rc_read_dictionary: invalid name length on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			if (!isdigit (*valstr))
+			{
+				error("rc_read_dictionary: invalid value on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+			value = atoi (valstr);
+
+			if (strcmp (typestr, "string") == 0)
+			{
+				type = PW_TYPE_STRING;
+			}
+			else if (strcmp (typestr, "integer") == 0)
+			{
+				type = PW_TYPE_INTEGER;
+			}
+			else if (strcmp (typestr, "ipaddr") == 0)
+			{
+				type = PW_TYPE_IPADDR;
+			}
+			else if (strcmp (typestr, "date") == 0)
+			{
+				type = PW_TYPE_DATE;
+			}
+			else
+			{
+				error("rc_read_dictionary: invalid type on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			/* Search for vendor if supplied */
+			if (*vendorstr) {
+			    vdict = rc_dict_findvendor(vendorstr);
+			    if (!vdict) {
+				    error("rc_read_dictionary: unknown vendor on line %d of dictionary %s",
+					  line_no, filename);
+				    retcode = -1;
+				    break;
+			    }
+			} else {
+			    vdict = NULL;
+			}
+			/* Create a new attribute for the list */
+			if ((attr =
+				(DICT_ATTR *) malloc (sizeof (DICT_ATTR)))
+							== (DICT_ATTR *) NULL)
+			{
+				novm("rc_read_dictionary");
+				retcode = -1;
+				break;
+			}
+			strcpy (attr->name, namestr);
+			if (vdict) {
+			    attr->vendorcode = vdict->vendorcode;
+			} else {
+			    attr->vendorcode = VENDOR_NONE;
+			}
+			attr->value = value;
+			attr->type = type;
+
+			/* Insert it into the list */
+			if (vdict) {
+			    attr->next = vdict->attributes;
+			    vdict->attributes = attr;
+			} else {
+			    attr->next = dictionary_attributes;
+			    dictionary_attributes = attr;
+			}
+		}
+		else if (strncmp (buffer, "VALUE", 5) == 0)
+		{
+			/* Read the VALUE line */
+			if (sscanf (buffer, "%s%s%s%s", dummystr, attrstr,
+				    namestr, valstr) != 4)
+			{
+				error("rc_read_dictionary: invalid value entry on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			/*
+			 * Validate all entries
+			 */
+			if (strlen (attrstr) > NAME_LENGTH)
+			{
+				error("rc_read_dictionary: invalid attribute length on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			if (strlen (namestr) > NAME_LENGTH)
+			{
+				error("rc_read_dictionary: invalid name length on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+
+			if (!isdigit (*valstr))
+			{
+				error("rc_read_dictionary: invalid value on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+			value = atoi (valstr);
+
+			/* Create a new VALUE entry for the list */
+			if ((dval =
+				(DICT_VALUE *) malloc (sizeof (DICT_VALUE)))
+							== (DICT_VALUE *) NULL)
+			{
+				novm("rc_read_dictionary");
+				retcode = -1;
+				break;
+			}
+			strcpy (dval->attrname, attrstr);
+			strcpy (dval->name, namestr);
+			dval->value = value;
+
+			/* Insert it into the list */
+			dval->next = dictionary_values;
+			dictionary_values = dval;
+		}
+		else if (strncmp (buffer, "INCLUDE", 7) == 0)
+		{
+			/* Read the INCLUDE line */
+			if (sscanf (buffer, "%s%s", dummystr, namestr) != 2)
+			{
+				error("rc_read_dictionary: invalid include entry on line %d of dictionary %s",
+				      line_no, filename);
+				retcode = -1;
+				break;
+			}
+			if (rc_read_dictionary(namestr) == -1)
+			{
+				retcode = -1;
+				break;
+			}
+		}
+	}
+	fclose (dictfd);
+	return retcode;
+}
+
+/*
+ * Function: rc_dict_getattr
+ *
+ * Purpose: Return the full attribute structure based on the
+ *	    attribute id number and vendor code.  If vendor code is VENDOR_NONE,
+ *          non-vendor-specific attributes are used
+ *
+ */
+
+DICT_ATTR *rc_dict_getattr (int attribute, int vendor)
+{
+	DICT_ATTR      *attr;
+	VENDOR_DICT    *dict;
+
+	if (vendor == VENDOR_NONE) {
+	    attr = dictionary_attributes;
+	    while (attr != (DICT_ATTR *) NULL) {
+		if (attr->value == attribute) {
+		    return (attr);
+		}
+		attr = attr->next;
+	    }
+	} else {
+	    dict = rc_dict_getvendor(vendor);
+	    if (!dict) {
+		return NULL;
+	    }
+	    attr = dict->attributes;
+	    while (attr) {
+		if (attr->value == attribute) {
+		    return attr;
+		}
+		attr = attr->next;
+	    }
+	}
+	return NULL;
+}
+
+/*
+ * Function: rc_dict_findattr
+ *
+ * Purpose: Return the full attribute structure based on the
+ *	    attribute name.
+ *
+ */
+
+DICT_ATTR *rc_dict_findattr (char *attrname)
+{
+	DICT_ATTR      *attr;
+	VENDOR_DICT    *dict;
+
+	attr = dictionary_attributes;
+	while (attr != (DICT_ATTR *) NULL)
+	{
+		if (strcasecmp (attr->name, attrname) == 0)
+		{
+			return (attr);
+		}
+		attr = attr->next;
+	}
+
+	/* Search vendor-specific dictionaries */
+	dict = vendor_dictionaries;
+	while (dict) {
+	    attr = dict->attributes;
+	    while (attr) {
+		if (strcasecmp (attr->name, attrname) == 0) {
+		    return (attr);
+		}
+		attr = attr->next;
+	    }
+	    dict = dict->next;
+	}
+	return ((DICT_ATTR *) NULL);
+}
+
+
+/*
+ * Function: rc_dict_findval
+ *
+ * Purpose: Return the full value structure based on the
+ *         value name.
+ *
+ */
+
+DICT_VALUE *rc_dict_findval (char *valname)
+{
+	DICT_VALUE     *val;
+
+	val = dictionary_values;
+	while (val != (DICT_VALUE *) NULL)
+	{
+		if (strcasecmp (val->name, valname) == 0)
+		{
+			return (val);
+		}
+		val = val->next;
+	}
+	return ((DICT_VALUE *) NULL);
+}
+
+/*
+ * Function: dict_getval
+ *
+ * Purpose: Return the full value structure based on the
+ *          actual value and the associated attribute name.
+ *
+ */
+
+DICT_VALUE * rc_dict_getval (UINT4 value, char *attrname)
+{
+	DICT_VALUE     *val;
+
+	val = dictionary_values;
+	while (val != (DICT_VALUE *) NULL)
+	{
+		if (strcmp (val->attrname, attrname) == 0 &&
+				val->value == value)
+		{
+			return (val);
+		}
+		val = val->next;
+	}
+	return ((DICT_VALUE *) NULL);
+}
+
+/*
+ * Function: rc_dict_findvendor
+ *
+ * Purpose: Return the vendor's dictionary given the vendor name.
+ *
+ */
+VENDOR_DICT * rc_dict_findvendor (char *vendorname)
+{
+    VENDOR_DICT *dict;
+
+    dict = vendor_dictionaries;
+    while (dict) {
+	if (!strcmp(vendorname, dict->vendorname)) {
+	    return dict;
+	}
+	dict = dict->next;
+    }
+    return NULL;
+}
+
+/*
+ * Function: rc_dict_getvendor
+ *
+ * Purpose: Return the vendor's dictionary given the vendor ID
+ *
+ */
+VENDOR_DICT * rc_dict_getvendor (int id)
+{
+    VENDOR_DICT *dict;
+
+    dict = vendor_dictionaries;
+    while (dict) {
+	if (id == dict->vendorcode) {
+	    return dict;
+	}
+	dict = dict->next;
+    }
+    return NULL;
+}
